#include "WProgram.h"
/**
 * Dual Polarity H-Bridge Control class
 * By: Zvika Markfeld
 *  
**/
class HBridge
{
private: 
  int _positive0;
  int _positive1;
  int _negative0;
  int _negative1;

public:
  void init(int positive0, int positive1, int negative0, int negative1);
  void forward();
  void backward();
  void stop();
  void idle();
};


/*********************************  PUBLIC ***********************************/
void HBridge::init(int positive0, int positive1, int negative0, int negative1) {
  _positive0 = positive0;
  _positive1 = positive1;
  _negative0 = negative0;
  _negative1 = negative1;
  pinMode(_positive0, OUTPUT); 
  pinMode(_positive1, OUTPUT); 
  pinMode(_negative0, OUTPUT); 
  pinMode(_negative1, OUTPUT); 
  idle();
}

void HBridge::forward() {
  idle();
  digitalWrite(_positive0, LOW);
  digitalWrite(_negative0, LOW);
  digitalWrite(_positive1, HIGH);
  digitalWrite(_negative1, HIGH);
}

void HBridge::backward() {
  idle();
  digitalWrite(_negative1, LOW);
  digitalWrite(_positive1, LOW);
  digitalWrite(_positive0, HIGH);
  digitalWrite(_negative0, HIGH);
}

void HBridge::stop() {
  idle();
}

void HBridge::idle() {
  digitalWrite(_positive0, LOW);
  digitalWrite(_positive1, LOW);
  digitalWrite(_negative0, LOW);
  digitalWrite(_negative1, LOW);
}











